package com.seeyon.apps.ocip.webservice.impl;

import java.util.HashMap;
import java.util.Map;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.seeyon.apps.govdoc.manager.GovdocManager;
import com.seeyon.apps.ocip.util.CommonUtil;
import com.seeyon.apps.ocip.webservice.OcipEdocService;
import com.seeyon.ctp.common.authenticate.domain.User;
import com.seeyon.ctp.common.exceptions.BusinessException;
import com.seeyon.ctp.organization.bo.V3xOrgMember;
import com.seeyon.ctp.organization.manager.OrgManager;

public class OcipEdocServiceImpl implements OcipEdocService{

	private static final Log log = LogFactory.getLog(OcipEdocServiceImpl.class);
	private GovdocManager govdocManager;
	private OrgManager orgManager;
	
	@Override
	public String[] takeBack(String affairId, String isSaveOpinion, String outMemberId, String curSummaryId,
			String caseId, String summaryId) {
		String[] ret=new String[2];
		setCurrentUser(outMemberId);
		try {
			Map<String,Object> param=new HashMap<String, Object>();
			param.put("affairId", affairId);
			param.put("isSaveOpinion", Boolean.valueOf(isSaveOpinion));
			param.put("curSummaryId", curSummaryId);
			param.put("caseId", caseId);
			param.put("summaryId", summaryId);
			Map<String, Object> map = govdocManager.transTakeBack(param);
			//ret[0]=msg==null?"":msg;
			ret[0] = (String)(map.get("msg")==null?"":map.get("msg"));
			ret[1] = ((Long)(map.get("caseId")==null?"":map.get("caseId"))).toString();
		} catch (BusinessException e) {
			log.error("->", e);
		}
		return ret;
	}
	private void setCurrentUser(String memberId){
		V3xOrgMember member=null;
		try {
			member = orgManager.getMemberById(Long.valueOf(memberId));
		} catch (NumberFormatException e) {
			log.error(e);
			//e.printStackTrace();
		} catch (BusinessException e) {
			log.error(e);
			//e.printStackTrace();
		}
		User user = new User();
		if(member != null){
			user.setId(Long.valueOf(member.getId()));
			user.setLoginAccount(member.getOrgAccountId());
			user.setAccountId(member.getOrgAccountId());
			user.setDepartmentId(member.getOrgDepartmentId());
			user.setName(member.getName());
		}
		user.setAuditAdmin(true);
		//标记为外系统单点登录来的请求
		user.setUserSSOFrom("other");
		CommonUtil.setCurrentUser(user);
	}
	public void setGovdocManager(GovdocManager govdocManager) {
		this.govdocManager = govdocManager;
	}
	public void setOrgManager(OrgManager orgManager) {
		this.orgManager = orgManager;
	}

}
